D2I_ASN1_OBJECT(3)

NAME
d2i_ASN1_OBJECT, i2d_ASN1_OBJECT - decode and encode ASN.1 object identifiers

SYNOPSIS
#include <openssl/asn1.h>
ASN1_OBJECT *
d2i_ASN1_OBJECT(ASN1_OBJECT **val_out, unsigned char **der_in, long length);
int
i2d_ASN1_OBJECT(ASN1_OBJECT *val_in, unsigned char **der_out);

DESCRIPTION
These functions decode and encode ASN.1 object identifiers. For details about the semantics, examples, caveats, and bugs, see ASN1_item_d2i(3).

The objects returned from d2i_ASN1_OBJECT() and the data contained in them are always marked as dynamically allocated, so when they are no longer needed, ASN1_OBJECT_free(3) can be called on them.

If reusing an existing object is attempted but the *val_out passed in points to an object that is not marked as dynamically allocated, then the existing object is left untouched and d2i_ASN1_OBJECT() behaves as if *val_out would have been NULL: A new object is allocated and a pointer to it is both stored in *val_out and returned.

RETURN VALUES
d2i_ASN1_OBJECT() returns an ASN1_OBJECT object or NULL if an error occurs.

i2d_ASN1_OBJECT() returns the number of bytes successfully encoded or a value <= 0 if an error occurs.

SEE ALSO
ASN1_item_d2i(3), ASN1_OBJECT_new(3), OBJ_nid2obj(3)

HISTORY
d2i_ASN1_OBJECT() and i2d_ASN1_OBJECT() appeared in SSLeay 0.8.1b or earlier and have been available since OpenBSD 2.4.

CAVEATS
d2i_ASN1_OBJECT() never sets the long and short names of the object, not even if the object identifier matches one that is built into the library. To find the names of an object identifier parsed from DER or BER input, call OBJ_obj2nid(3) on the returned object, and then OBJ_nid2sn(3) and OBJ_nid2ln(3) on the result.

BUGS
When reusing a dynamically allocated object that contains dynamically allocated names, the old names are not freed and the memory containing them is leaked.